Gerador TOTP (códigos 2FA)

Gere senhas de uso único baseadas em tempo (TOTP) a partir de uma chave Base32, com SHA-1/256/512, 6–8 dígitos e qualquer período. Contagem regressiva ao vivo, RFC 6238 validado.

A chave exibida pelo serviço ao ativar a 2FA. Espaços e minúsculas são aceitos.

Deixe vazio para usar a hora atual.

O TOTP (RFC 6238) calcula o HOTP com o contador T = floor(tempo Unix / período). A maioria dos apps usa SHA-1, 6 dígitos e 30 segundos. O relógio do dispositivo precisa estar certo. A chave nunca sai do seu navegador, mas trate-a como uma senha.

Executa totalmente no seu navegador. Seus dados nunca são enviados.

O que é Gerador TOTP (2FA)?

Esta ferramenta calcula os mesmos códigos de 6–8 dígitos que os apps autenticadores mostram, a partir de uma chave secreta Base32. Ela se atualiza ao vivo com uma contagem regressiva, mostra também o código anterior e o próximo e pode calcular o código para qualquer tempo Unix, para testar servidores.

Como usar Gerador TOTP (2FA)

  1. Cole a Chave secreta (Base32) ou clique em Nova chave aleatória.
  2. Defina Algoritmo, Dígitos e Período conforme o serviço (normalmente SHA-1, 6, 30).
  3. Leia o código atual e os segundos restantes.
  4. Opcionalmente, informe um Tempo Unix para calcular o código de um momento específico.

Exemplo

Entrada
Secret GEZDGNBVGY3TQOJQGEZDGNBVGY3TQOJQ, SHA-1, 8 digits, Unix time 59
Saída
94287082

Vetor de teste do Apêndice B do RFC 6238 (a chave é o ASCII 12345678901234567890 em Base32).

Quando usar Gerador TOTP (2FA)

Use para testar uma implementação de 2FA, recuperar códigos no computador quando você tem a chave ou entender como o TOTP funciona. Não deixe as chaves das suas contas reais em abas do navegador; use um app autenticador ou um gerenciador de senhas.

Como funciona Gerador TOTP (2FA)

O TOTP (RFC 6238) calcula o HOTP (RFC 4226) com o contador T = floor(tempo Unix / período): HMAC-SHA-1/256/512 do contador de 8 bytes big-endian, com a chave secreta decodificada de Base32, seguido de truncamento dinâmico (offset = último nibble) e módulo 10^dígitos. O HMAC é calculado com a Web Crypto API. Todos os vetores de teste do Apêndice B do RFC 6238 são reproduzidos exatamente.

Casos de Uso Comuns

  • Testar o login TOTP de uma aplicação web em desenvolvimento
  • Verificar o desvio do relógio do servidor comparando códigos
  • Reproduzir os vetores de teste do RFC 6238
  • Gerar códigos para uma conta de teste em documentação de CI

Nota de Segurança

Uma chave TOTP é tão sensível quanto uma senha: quem a tiver consegue gerar os seus códigos.

Perguntas Frequentes

Por que meus códigos não batem com os do app?

Confira se o algoritmo, os dígitos e o período coincidem e se o relógio do computador está certo; uma diferença de 30 segundos no relógio muda o código.

Minha chave é enviada para algum lugar?

Não. O HMAC é calculado no seu navegador com a Web Crypto.

Qual alfabeto Base32 é usado?

O do RFC 4648: A–Z e 2–7. Espaços, hífens, minúsculas e o padding = são aceitos e ignorados.

Explore mais categorias